SDL_haptic.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_error.h"`
`#include "SDL_joystick.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_haptic.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_HapticDirection
struct | SDL_HapticConstant
struct | SDL_HapticPeriodic
struct | SDL_HapticCondition
struct | SDL_HapticRamp
struct | SDL_HapticLeftRight
struct | SDL_HapticCustom
union | SDL_HapticEffect

## Macros

Haptic effects
#define | SDL_HAPTIC_CONSTANT (1u<<0)
#define | SDL_HAPTIC_SINE (1u<<1)
#define | SDL_HAPTIC_LEFTRIGHT (1u<<2)
#define | SDL_HAPTIC_TRIANGLE (1u<<3)
#define | SDL_HAPTIC_SAWTOOTHUP (1u<<4)
#define | SDL_HAPTIC_SAWTOOTHDOWN (1u<<5)
#define | SDL_HAPTIC_RAMP (1u<<6)
#define | SDL_HAPTIC_SPRING (1u<<7)
#define | SDL_HAPTIC_DAMPER (1u<<8)
#define | SDL_HAPTIC_INERTIA (1u<<9)
#define | SDL_HAPTIC_FRICTION (1u<<10)
#define | SDL_HAPTIC_CUSTOM (1u<<11)
#define | SDL_HAPTIC_GAIN (1u<<12)
#define | SDL_HAPTIC_AUTOCENTER (1u<<13)
#define | SDL_HAPTIC_STATUS (1u<<14)
#define | SDL_HAPTIC_PAUSE (1u<<15)

## Typedefs

typedef struct _SDL_Haptic | SDL_Haptic
| The haptic structure used to identify an SDL haptic.

## Direction encodings

#define | SDL_HAPTIC_POLAR 0
#define | SDL_HAPTIC_CARTESIAN 1
#define | SDL_HAPTIC_SPHERICAL 2
#define | SDL_HAPTIC_STEERING_AXIS 3
#define | SDL_HAPTIC_INFINITY 4294967295U
int | SDL_NumHaptics (void)
const char * | SDL_HapticName (int device_index)
SDL_Haptic * | SDL_HapticOpen (int device_index)
int | SDL_HapticOpened (int device_index)
int | SDL_HapticIndex (SDL_Haptic *haptic)
int | SDL_MouseIsHaptic (void)
SDL_Haptic * | SDL_HapticOpenFromMouse (void)
int | SDL_JoystickIsHaptic (SDL_Joystick *joystick)
SDL_Haptic * | SDL_HapticOpenFromJoystick (SDL_Joystick *joystick)
void | SDL_HapticClose (SDL_Haptic *haptic)
int | SDL_HapticNumEffects (SDL_Haptic *haptic)
int | SDL_HapticNumEffectsPlaying (SDL_Haptic *haptic)
unsigned int | SDL_HapticQuery (SDL_Haptic *haptic)
int | SDL_HapticNumAxes (SDL_Haptic *haptic)
int | SDL_HapticEffectSupported (SDL_Haptic *haptic, SDL_HapticEffect *effect)
int | SDL_HapticNewEffect (SDL_Haptic *haptic, SDL_HapticEffect *effect)
int | SDL_HapticUpdateEffect (SDL_Haptic *haptic, int effect, SDL_HapticEffect *data)
int | SDL_HapticRunEffect (SDL_Haptic *haptic, int effect, Uint32 iterations)
int | SDL_HapticStopEffect (SDL_Haptic *haptic, int effect)
void | SDL_HapticDestroyEffect (SDL_Haptic *haptic, int effect)
int | SDL_HapticGetEffectStatus (SDL_Haptic *haptic, int effect)
int | SDL_HapticSetGain (SDL_Haptic *haptic, int gain)
int | SDL_HapticSetAutocenter (SDL_Haptic *haptic, int autocenter)
int | SDL_HapticPause (SDL_Haptic *haptic)
int | SDL_HapticUnpause (SDL_Haptic *haptic)
int | SDL_HapticStopAll (SDL_Haptic *haptic)
int | SDL_HapticRumbleSupported (SDL_Haptic *haptic)
int | SDL_HapticRumbleInit (SDL_Haptic *haptic)
int | SDL_HapticRumblePlay (SDL_Haptic *haptic, float strength, Uint32 length)
int | SDL_HapticRumbleStop (SDL_Haptic *haptic)

## Macro Definition Documentation

## SDL_HAPTIC_AUTOCENTER

#define SDL_HAPTIC_AUTOCENTER (1u<<13)

Device can set autocenter.

Device supports setting autocenter.

See also
  SDL_HapticSetAutocenter

Definition at line 291 of file SDL_haptic.h.

## SDL_HAPTIC_CARTESIAN

#define SDL_HAPTIC_CARTESIAN 1

Uses cartesian coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 330 of file SDL_haptic.h.

## SDL_HAPTIC_CONSTANT

#define SDL_HAPTIC_CONSTANT (1u<<0)

Constant effect supported.

Constant haptic effect.

See also
  SDL_HapticCondition

Definition at line 165 of file SDL_haptic.h.

## SDL_HAPTIC_CUSTOM

#define SDL_HAPTIC_CUSTOM (1u<<11)

Custom effect is supported.

User defined custom haptic effect.

Definition at line 269 of file SDL_haptic.h.

## SDL_HAPTIC_DAMPER

#define SDL_HAPTIC_DAMPER (1u<<8)

Damper effect supported - uses axes velocity.

Condition haptic effect that simulates dampening. Effect is based on the axes velocity.

See also
  SDL_HapticCondition

Definition at line 242 of file SDL_haptic.h.

## SDL_HAPTIC_FRICTION

#define SDL_HAPTIC_FRICTION (1u<<10)

Friction effect supported - uses axes movement.

Condition haptic effect that simulates friction. Effect is based on the axes movement.

See also
  SDL_HapticCondition

Definition at line 262 of file SDL_haptic.h.

## SDL_HAPTIC_GAIN

#define SDL_HAPTIC_GAIN (1u<<12)

Device can set global gain.

Device supports setting the global gain.

See also
  SDL_HapticSetGain

Definition at line 282 of file SDL_haptic.h.

## SDL_HAPTIC_INERTIA

#define SDL_HAPTIC_INERTIA (1u<<9)

Inertia effect supported - uses axes acceleration.

Condition haptic effect that simulates inertia. Effect is based on the axes acceleration.

See also
  SDL_HapticCondition

Definition at line 252 of file SDL_haptic.h.

## SDL_HAPTIC_INFINITY

#define SDL_HAPTIC_INFINITY 4294967295U

Used to play a device an infinite number of times.

See also
  SDL_HapticRunEffect

Definition at line 362 of file SDL_haptic.h.

## SDL_HAPTIC_LEFTRIGHT

#define SDL_HAPTIC_LEFTRIGHT (1u<<2)

Left/Right effect supported.

Haptic effect for direct control over high/low frequency motors.

See also
  SDL_HapticLeftRight

Definition at line 183 of file SDL_haptic.h.

## SDL_HAPTIC_PAUSE

#define SDL_HAPTIC_PAUSE (1u<<15)

Device can be paused.

Devices supports being paused.

See also
  SDL_HapticPause
  SDL_HapticUnpause

Definition at line 310 of file SDL_haptic.h.

## SDL_HAPTIC_POLAR

#define SDL_HAPTIC_POLAR 0

Uses polar coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 323 of file SDL_haptic.h.

## SDL_HAPTIC_RAMP

#define SDL_HAPTIC_RAMP (1u<<6)

Ramp effect supported.

Ramp haptic effect.

See also
  SDL_HapticRamp

Definition at line 222 of file SDL_haptic.h.

## SDL_HAPTIC_SAWTOOTHDOWN

#define SDL_HAPTIC_SAWTOOTHDOWN (1u<<5)

Sawtoothdown wave effect supported.

Periodic haptic effect that simulates saw tooth down waves.

See also
  SDL_HapticPeriodic

Definition at line 213 of file SDL_haptic.h.

## SDL_HAPTIC_SAWTOOTHUP

#define SDL_HAPTIC_SAWTOOTHUP (1u<<4)

Sawtoothup wave effect supported.

Periodic haptic effect that simulates saw tooth up waves.

See also
  SDL_HapticPeriodic

Definition at line 204 of file SDL_haptic.h.

## SDL_HAPTIC_SINE

#define SDL_HAPTIC_SINE (1u<<1)

Sine wave effect supported.

Periodic haptic effect that simulates sine waves.

See also
  SDL_HapticPeriodic

Definition at line 174 of file SDL_haptic.h.

## SDL_HAPTIC_SPHERICAL

#define SDL_HAPTIC_SPHERICAL 2

Uses spherical coordinates for the direction.

See also
  SDL_HapticDirection

Definition at line 337 of file SDL_haptic.h.

## SDL_HAPTIC_SPRING

#define SDL_HAPTIC_SPRING (1u<<7)

Spring effect supported - uses axes position.

Condition haptic effect that simulates a spring. Effect is based on the axes position.

See also
  SDL_HapticCondition

Definition at line 232 of file SDL_haptic.h.

## SDL_HAPTIC_STATUS

#define SDL_HAPTIC_STATUS (1u<<14)

Device can be queried for effect status.

Device supports querying effect status.

See also
  SDL_HapticGetEffectStatus

Definition at line 300 of file SDL_haptic.h.

## SDL_HAPTIC_STEERING_AXIS

#define SDL_HAPTIC_STEERING_AXIS 3

Use this value to play an effect on the steering wheel axis.

This provides better compatibility across platforms and devices as SDL will guess the correct axis.

See also
  SDL_HapticDirection

Definition at line 347 of file SDL_haptic.h.

## SDL_HAPTIC_TRIANGLE

#define SDL_HAPTIC_TRIANGLE (1u<<3)

Triangle wave effect supported.

Periodic haptic effect that simulates triangular waves.

See also
  SDL_HapticPeriodic

Definition at line 195 of file SDL_haptic.h.

## Typedef Documentation

## SDL_Haptic

typedef struct _SDL_Haptic SDL_Haptic

The haptic structure used to identify an SDL haptic.

# CategoryHaptic

SDL haptic subsystem allows you to control haptic (force feedback) devices.

The basic usage is as follows:

- Initialize the subsystem (SDL_INIT_HAPTIC).
- Open a haptic device.
- SDL_HapticOpen() to open from index.
- SDL_HapticOpenFromJoystick() to open from an existing joystick.
- Create an effect (SDL_HapticEffect).
- Upload the effect with SDL_HapticNewEffect().
- Run the effect with SDL_HapticRunEffect().
- (optional) Free the effect with SDL_HapticDestroyEffect().
- Close the haptic device with SDL_HapticClose().

Simple rumble example:

SDL_Haptic *haptic;
// Open the device
haptic = SDL_HapticOpen( 0 );
if (haptic == NULL)
return -1;
// Initialize simple rumble
if (SDL_HapticRumbleInit( haptic ) != 0)
return -1;
// Play effect at 50% strength for 2 seconds
if (SDL_HapticRumblePlay( haptic, 0.5, 2000 ) != 0)
return -1;
SDL_Delay( 2000 );
// Clean up
SDL_HapticClose( haptic );
SDL_HapticRumblePlay
int SDL_HapticRumblePlay(SDL_Haptic *haptic, float strength, Uint32 length)
SDL_HapticRumbleInit
int SDL_HapticRumbleInit(SDL_Haptic *haptic)
SDL_HapticClose
void SDL_HapticClose(SDL_Haptic *haptic)
SDL_Haptic
struct _SDL_Haptic SDL_Haptic
The haptic structure used to identify an SDL haptic.
Definition SDL_haptic.h:143
SDL_HapticOpen
SDL_Haptic * SDL_HapticOpen(int device_index)
SDL_Delay
void SDL_Delay(Uint32 ms)
NULL
#define NULL
Definition begin_code.h:165

Complete example:

int test_haptic( SDL_Joystick * joystick ) {
SDL_Haptic *haptic;
SDL_HapticEffect effect;
int effect_id;
// Open the device
haptic = SDL_HapticOpenFromJoystick( joystick );
if (haptic == NULL) return -1; // Most likely joystick isn't haptic
// See if it can do sine waves
if ((SDL_HapticQuery(haptic) & SDL_HAPTIC_SINE)==0) {
SDL_HapticClose(haptic); // No sine effect
return -1;
}
// Create the effect
SDL_memset( &effect, 0, sizeof(SDL_HapticEffect) ); // 0 is safe default
effect.type = SDL_HAPTIC_SINE;
effect.periodic.direction.type = SDL_HAPTIC_POLAR; // Polar coordinates
effect.periodic.direction.dir[0] = 18000; // Force comes from south
effect.periodic.period = 1000; // 1000 ms
effect.periodic.magnitude = 20000; // 20000/32767 strength
effect.periodic.length = 5000; // 5 seconds long
effect.periodic.attack_length = 1000; // Takes 1 second to get max strength
effect.periodic.fade_length = 1000; // Takes 1 second to fade away
// Upload the effect
effect_id = SDL_HapticNewEffect( haptic, &effect );
// Test the effect
SDL_HapticRunEffect( haptic, effect_id, 1 );
SDL_Delay( 5000); // Wait for the effect to finish
// We destroy the effect, although closing the device also does this
SDL_HapticDestroyEffect( haptic, effect_id );
// Close the device
SDL_HapticClose(haptic);
return 0; // Success
}
SDL_HapticQuery
unsigned int SDL_HapticQuery(SDL_Haptic *haptic)
SDL_HapticNewEffect
int SDL_HapticNewEffect(SDL_Haptic *haptic, SDL_HapticEffect *effect)
SDL_HapticOpenFromJoystick
SDL_Haptic * SDL_HapticOpenFromJoystick(SDL_Joystick *joystick)
SDL_HapticDestroyEffect
void SDL_HapticDestroyEffect(SDL_Haptic *haptic, int effect)
SDL_HapticRunEffect
int SDL_HapticRunEffect(SDL_Haptic *haptic, int effect, Uint32 iterations)
SDL_HAPTIC_SINE
#define SDL_HAPTIC_SINE
Definition SDL_haptic.h:174
SDL_HAPTIC_POLAR
#define SDL_HAPTIC_POLAR
Definition SDL_haptic.h:323
SDL_Joystick
struct _SDL_Joystick SDL_Joystick
Definition SDL_joystick.h:78
SDL_memset
void * SDL_memset(SDL_OUT_BYTECAP(len) void *dst, int c, size_t len)
SDL_HapticDirection::dir
Sint32 dir[3]
Definition SDL_haptic.h:469
SDL_HapticDirection::type
Uint8 type
Definition SDL_haptic.h:468
SDL_HapticPeriodic::period
Uint16 period
Definition SDL_haptic.h:585
SDL_HapticPeriodic::length
Uint32 length
Definition SDL_haptic.h:577
SDL_HapticPeriodic::direction
SDL_HapticDirection direction
Definition SDL_haptic.h:574
SDL_HapticPeriodic::magnitude
Sint16 magnitude
Definition SDL_haptic.h:586
SDL_HapticPeriodic::attack_length
Uint16 attack_length
Definition SDL_haptic.h:591
SDL_HapticPeriodic::fade_length
Uint16 fade_length
Definition SDL_haptic.h:593
SDL_HapticEffect
Definition SDL_haptic.h:822
SDL_HapticEffect::type
Uint16 type
Definition SDL_haptic.h:824
SDL_HapticEffect::periodic
SDL_HapticPeriodic periodic
Definition SDL_haptic.h:826

See also
  SDL_HapticOpen
  SDL_HapticOpenFromJoystick
  SDL_HapticClose

Definition at line 143 of file SDL_haptic.h.

## Function Documentation

## SDL_HapticClose()

void SDL_HapticClose | ( | SDL_Haptic * | haptic | ) |

extern

Close a haptic device previously opened with SDL_HapticOpen().

Parameters

  haptic | the SDL_Haptic device to close.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpen

## SDL_HapticDestroyEffect()

void SDL_HapticDestroyEffect | ( | SDL_Haptic * | haptic,
|  | int | effect )

extern

Destroy a haptic effect on the device.

This will stop the effect if it's running. Effects are automatically destroyed when the device is closed.

Parameters

  haptic | the SDL_Haptic device to destroy the effect on.
  effect | the ID of the haptic effect to destroy.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticNewEffect

## SDL_HapticEffectSupported()

int SDL_HapticEffectSupported | ( | SDL_Haptic * | haptic,
|  | SDL_HapticEffect * | effect )

extern

Check to see if an effect is supported by a haptic device.

Parameters

  haptic | the SDL_Haptic device to query.
  effect | the desired effect to query.

Returns
  SDL_TRUE if effect is supported, SDL_FALSE if it isn't, or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticNewEffect
  SDL_HapticQuery

## SDL_HapticGetEffectStatus()

int SDL_HapticGetEffectStatus | ( | SDL_Haptic * | haptic,
|  | int | effect )

extern

Get the status of the current effect on the specified haptic device.

Device must support the SDL_HAPTIC_STATUS feature.

Parameters

  haptic | the SDL_Haptic device to query for the effect status on.
  effect | the ID of the haptic effect to query its status.

Returns
  0 if it isn't playing, 1 if it is playing, or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticRunEffect
  SDL_HapticStopEffect

## SDL_HapticIndex()

int SDL_HapticIndex | ( | SDL_Haptic * | haptic | ) |

extern

Get the index of a haptic device.

Parameters

  haptic | the SDL_Haptic device to query.

Returns
  the index of the specified haptic device or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpen
  SDL_HapticOpened

## SDL_HapticName()

const char * SDL_HapticName | ( | int | device_index | ) |

extern

Get the implementation dependent name of a haptic device.

This can be called before any joysticks are opened. If no name can be found, this function returns NULL.

Parameters

  device_index | index of the device to query.

Returns
  the name of the device or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_NumHaptics

## SDL_HapticNewEffect()

int SDL_HapticNewEffect | ( | SDL_Haptic * | haptic,
|  | SDL_HapticEffect * | effect )

extern

Create a new haptic effect on a specified device.

Parameters

  haptic | an SDL_Haptic device to create the effect on.
  effect | an SDL_HapticEffect structure containing the properties of the effect to create.

Returns
  the ID of the effect on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticDestroyEffect
  SDL_HapticRunEffect
  SDL_HapticUpdateEffect

## SDL_HapticNumAxes()

int SDL_HapticNumAxes | ( | SDL_Haptic * | haptic | ) |

extern

Get the number of haptic axes the device has.

The number of haptic axes might be useful if working with the SDL_HapticDirection effect.

Parameters

  haptic | the SDL_Haptic device to query.

Returns
  the number of axes on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_HapticNumEffects()

int SDL_HapticNumEffects | ( | SDL_Haptic * | haptic | ) |

extern

Get the number of effects a haptic device can store.

On some platforms this isn't fully supported, and therefore is an approximation. Always check to see if your created effect was actually created and do not rely solely on SDL_HapticNumEffects().

Parameters

  haptic | the SDL_Haptic device to query.

Returns
  the number of effects the haptic device can store or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticNumEffectsPlaying
  SDL_HapticQuery

## SDL_HapticNumEffectsPlaying()

int SDL_HapticNumEffectsPlaying | ( | SDL_Haptic * | haptic | ) |

extern

Get the number of effects a haptic device can play at the same time.

This is not supported on all platforms, but will always return a value.

Parameters

  haptic | the SDL_Haptic device to query maximum playing effects.

Returns
  the number of effects the haptic device can play at the same time or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticNumEffects
  SDL_HapticQuery

## SDL_HapticOpen()

SDL_Haptic * SDL_HapticOpen | ( | int | device_index | ) |

extern

Open a haptic device for use.

The index passed as an argument refers to the N'th haptic device on this system.

When opening a haptic device, its gain will be set to maximum and autocenter will be disabled. To modify these values use SDL_HapticSetGain() and SDL_HapticSetAutocenter().

Parameters

  device_index | index of the device to open.

Returns
  the device identifier or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticClose
  SDL_HapticIndex
  SDL_HapticOpenFromJoystick
  SDL_HapticOpenFromMouse
  SDL_HapticPause
  SDL_HapticSetAutocenter
  SDL_HapticSetGain
  SDL_HapticStopAll

## SDL_HapticOpened()

int SDL_HapticOpened | ( | int | device_index | ) |

extern

Check if the haptic device at the designated index has been opened.

Parameters

  device_index | the index of the device to query.

Returns
  1 if it has been opened, 0 if it hasn't or on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticIndex
  SDL_HapticOpen

## SDL_HapticOpenFromJoystick()

SDL_Haptic * SDL_HapticOpenFromJoystick | ( | SDL_Joystick * | joystick | ) |

extern

Open a haptic device for use from a joystick device.

You must still close the haptic device separately. It will not be closed with the joystick.

When opened from a joystick you should first close the haptic device before closing the joystick device. If not, on some implementations the haptic device will also get unallocated and you'll be unable to use force feedback on that device.

Parameters

  joystick | the SDL_Joystick to create a haptic device from.

Returns
  a valid haptic device identifier on success or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticClose
  SDL_HapticOpen
  SDL_JoystickIsHaptic

## SDL_HapticOpenFromMouse()

SDL_Haptic * SDL_HapticOpenFromMouse | ( | void |  | ) |

extern

Try to open a haptic device from the current mouse.

Returns
  the haptic device identifier or NULL on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpen
  SDL_MouseIsHaptic

## SDL_HapticPause()

int SDL_HapticPause | ( | SDL_Haptic * | haptic | ) |

extern

Pause a haptic device.

Device must support the SDL_HAPTIC_PAUSE feature. Call SDL_HapticUnpause() to resume playback.

Do not modify the effects nor add new ones while the device is paused. That can cause all sorts of weird errors.

Parameters

  haptic | the SDL_Haptic device to pause.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticUnpause

## SDL_HapticQuery()

unsigned int SDL_HapticQuery | ( | SDL_Haptic * | haptic | ) |

extern

Get the haptic device's supported features in bitwise manner.

Parameters

  haptic | the SDL_Haptic device to query.

Returns
  a list of supported haptic features in bitwise manner (OR'd), or 0 on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticEffectSupported
  SDL_HapticNumEffects

## SDL_HapticRumbleInit()

int SDL_HapticRumbleInit | ( | SDL_Haptic * | haptic | ) |

extern

Initialize a haptic device for simple rumble playback.

Parameters

  haptic | the haptic device to initialize for simple rumble playback.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpen
  SDL_HapticRumblePlay
  SDL_HapticRumbleStop
  SDL_HapticRumbleSupported

## SDL_HapticRumblePlay()

int SDL_HapticRumblePlay | ( | SDL_Haptic * | haptic,
|  | float | strength,
|  | Uint32 | length )

extern

Run a simple rumble effect on a haptic device.

Parameters

  haptic | the haptic device to play the rumble effect on.
  strength | strength of the rumble to play as a 0-1 float value.
  length | length of the rumble to play in milliseconds.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticRumbleInit
  SDL_HapticRumbleStop
  SDL_HapticRumbleSupported

## SDL_HapticRumbleStop()

int SDL_HapticRumbleStop | ( | SDL_Haptic * | haptic | ) |

extern

Stop the simple rumble on a haptic device.

Parameters

  haptic | the haptic device to stop the rumble effect on.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticRumbleInit
  SDL_HapticRumblePlay
  SDL_HapticRumbleSupported

## SDL_HapticRumbleSupported()

int SDL_HapticRumbleSupported | ( | SDL_Haptic * | haptic | ) |

extern

Check whether rumble is supported on a haptic device.

Parameters

  haptic | haptic device to check for rumble support.

Returns
  SDL_TRUE if effect is supported, SDL_FALSE if it isn't, or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticRumbleInit
  SDL_HapticRumblePlay
  SDL_HapticRumbleStop

## SDL_HapticRunEffect()

int SDL_HapticRunEffect | ( | SDL_Haptic * | haptic,
|  | int | effect,
|  | Uint32 | iterations )

extern

Run the haptic effect on its associated haptic device.

To repeat the effect over and over indefinitely, set iterations to SDL_HAPTIC_INFINITY. (Repeats the envelope - attack and fade.) To make one instance of the effect last indefinitely (so the effect does not fade), set the effect's length in its structure/union to SDL_HAPTIC_INFINITY instead.

Parameters

  haptic | the SDL_Haptic device to run the effect on.
  effect | the ID of the haptic effect to run.
  iterations | the number of iterations to run the effect; use SDL_HAPTIC_INFINITY to repeat forever.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticDestroyEffect
  SDL_HapticGetEffectStatus
  SDL_HapticStopEffect

## SDL_HapticSetAutocenter()

int SDL_HapticSetAutocenter | ( | SDL_Haptic * | haptic,
|  | int | autocenter )

extern

Set the global autocenter of the device.

Autocenter should be between 0 and 100. Setting it to 0 will disable autocentering.

Device must support the SDL_HAPTIC_AUTOCENTER feature.

Parameters

  haptic | the SDL_Haptic device to set autocentering on.
  autocenter | value to set autocenter to (0-100).

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticQuery

## SDL_HapticSetGain()

int SDL_HapticSetGain | ( | SDL_Haptic * | haptic,
|  | int | gain )

extern

Set the global gain of the specified haptic device.

Device must support the SDL_HAPTIC_GAIN feature.

The user may specify the maximum gain by setting the environment variable SDL_HAPTIC_GAIN_MAX which should be between 0 and 100. All calls to SDL_HapticSetGain() will scale linearly using SDL_HAPTIC_GAIN_MAX as the maximum.

Parameters

  haptic | the SDL_Haptic device to set the gain on.
  gain | value to set the gain to, should be between 0 and 100 (0 - 100).

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticQuery

## SDL_HapticStopAll()

int SDL_HapticStopAll | ( | SDL_Haptic * | haptic | ) |

extern

Stop all the currently playing effects on a haptic device.

Parameters

  haptic | the SDL_Haptic device to stop.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_HapticStopEffect()

int SDL_HapticStopEffect | ( | SDL_Haptic * | haptic,
|  | int | effect )

extern

Stop the haptic effect on its associated haptic device.

- Parameters

    haptic | the SDL_Haptic device to stop the effect on.
    effect | the ID of the haptic effect to stop.

  Returns
    0 on success or a negative error code on failure; call SDL_GetError() for more information.
  Since
    This function is available since SDL 2.0.0.
  See also
    SDL_HapticDestroyEffect
    SDL_HapticRunEffect

## SDL_HapticUnpause()

int SDL_HapticUnpause | ( | SDL_Haptic * | haptic | ) |

extern

Unpause a haptic device.

Call to unpause after SDL_HapticPause().

Parameters

  haptic | the SDL_Haptic device to unpause.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticPause

## SDL_HapticUpdateEffect()

int SDL_HapticUpdateEffect | ( | SDL_Haptic * | haptic,
|  | int | effect,
|  | SDL_HapticEffect * | data )

extern

Update the properties of an effect.

Can be used dynamically, although behavior when dynamically changing direction may be strange. Specifically the effect may re-upload itself and start playing from the start. You also cannot change the type either when running SDL_HapticUpdateEffect().

Parameters

  haptic | the SDL_Haptic device that has the effect.
  effect | the identifier of the effect to update.
  data | an SDL_HapticEffect structure containing the new effect properties to use.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticDestroyEffect
  SDL_HapticNewEffect
  SDL_HapticRunEffect

## SDL_JoystickIsHaptic()

int SDL_JoystickIsHaptic | ( | SDL_Joystick * | joystick | ) |

extern

Query if a joystick has haptic features.

Parameters

  joystick | the SDL_Joystick to test for haptic capabilities.

Returns
  SDL_TRUE if the joystick is haptic, SDL_FALSE if it isn't, or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpenFromJoystick

## SDL_MouseIsHaptic()

int SDL_MouseIsHaptic | ( | void |  | ) |

extern

Query whether or not the current mouse has haptic capabilities.

Returns
  SDL_TRUE if the mouse is haptic or SDL_FALSE if it isn't.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticOpenFromMouse

## SDL_NumHaptics()

int SDL_NumHaptics | ( | void |  | ) |

extern

Count the number of haptic devices attached to the system.

Returns
  the number of haptic devices detected on the system or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HapticName